import{s as ct,n as gt,o as mt}from"../chunks/scheduler.7bc62968.js";import{S as ut,i as ft,g as s,s as a,r as c,A as pt,h as l,f as i,c as o,j as lt,u as g,x as r,k as rt,y as ht,a as n,v as m,d as u,t as f,w as p}from"../chunks/index.2f8492b0.js";import{H as d,E as dt}from"../chunks/EditOnGithub.2a9ce03a.js";function vt(Ie){let h,Z,X,ee,v,te,w,je="We hope you liked exploring the unit on ethics and bias in computer vision. As we conclude this unit, let us take a look into the efforts by Hugging Face to improve ethics in society. This chapter will encourage you to explore the world of ethics and bias in AI in general, which is constantly evolving. Hugging Face’s core mission is to <em>democratize good machine learning</em>. So what is Good ML? There are some principles for Good ML.",ie,y,ne,$,qe=`<strong>1. Collaboration:</strong> Providing tools for easier collaboration with the open-source community. Some examples of these tools are:
a. <a href="https://huggingface.co/docs/hub/model-cards" rel="nofollow"><em>Model Cards</em></a> are files that accompany the models and provide information about the model, its intended uses and potential limitations (including ethical considerations), training parameters and experimental information, datasets used for training and evaluation results. This ensures that the models uploaded to the hub are transparent and open to the community.
b. <a href="https://huggingface.co/blog/eval-on-the-hub" rel="nofollow"><em>Evaluation</em></a> lets users to evaluate any model on any dataset that is openly available on the Hub without writing a single line of code. ,
c. <a href="https://huggingface.co/blog/community-update" rel="nofollow"><em>Community discussion</em></a> is important, whether you upload a model, dataset or a space or you just want to know more about them from the authors. Everyone can give feedback, flag a given Space, and improve or contribute directly to the repository via PRs.
d. <a href="https://discord.com/invite/JfAtkvEtRb" rel="nofollow"><em>Discord</em></a> group for the 🤗 community, where a wide range of channels discuss about different domains like reinforcement-learning, NLP, game development, audio, computer vision and so on.
<strong>2. Transparency:</strong> Being transparent about the intent, sources of data, model training and performance. Efforts in this direction include:
a. <a href="https://huggingface.co/blog/ethical-charter-multimodal" rel="nofollow"><em>Ethical charter for multimodal project</em></a> discusses the values of the multimodal learning group at 🤗. This is a project-specific charter.
b. <a href="https://huggingface.co/blog/us-national-ai-research-resource" rel="nofollow"><em>Work on AI policy @</em> 🤗</a> mentions the response of Hugging Face on U.S. National AI Research Resource Interim Report.
<strong>3. Responsibility:</strong> Assessing the impacts of ML models and tools, and making them more auditable and understandable even for people with less expertise on ML. Some efforts in this directions are:
a. <a href="https://huggingface.co/blog/education" rel="nofollow">🤗 <em>for Education Project</em></a> aims at educating people from all backgrounds, beginners and instructors. Various experts and team members organize meetups, conferences and workshops.<br/>
b. <a href="https://huggingface.co/spaces/huggingface/data-measurements-tool" rel="nofollow"><em>Data Measurement Tool</em></a> is an interactive interface and open-source library that lets dataset creators and users automatically calculate metrics that are meaningful and useful for responsible data development.`,ae,x,oe,b,Fe="As we move forward, let us now take a look into how spaces are categorized by Hugging Face. Hugging Face categorizes the spaces in 6 high levels based on the ethical aspects in Machine Learning. Hugging Face Spaces are categorized as:",se,C,le,T,Re="Rigorous projects pay special attention to examining failure cases, protecting privacy through security measures, and ensuring that potential users (technical and non-technical) are informed of the project’s limitations. Some examples:",re,L,Ue="<li>Projects built with models that are well-documented with Model Cards.</li> <li>Tools that provide transparency into how a model was trained and how it behaves.</li> <li>Evaluations against cutting-edge benchmarks, with results reported against disaggregated sets.</li> <li>Demonstrations of models failing across gender, skin type, ethnicity, age or other attributes.</li> <li>Techniques for mitigating issues like over-fitting and training data memorization.</li> <li>Techniques for detoxifying language models.</li>",ce,H,Ge='An example space is the <a href="https://huggingface.co/spaces/society-ethics/DiffusionBiasExplorer" rel="nofollow"><strong>Diffusion Bias Explorer</strong></a> which lets the users compare three text-to-image models SD 1.4, SD 2.0 and Dall-E 2 for different prompts and how they represent different professions and adjectives.',ge,M,me,_,Be="Consentful technology supports the self-determination of people who use and are affected by these technologies. Some examples:",ue,k,Oe="<li>Demonstrating a commitment to acquiring data from willing, informed, and appropriately compensated sources.</li> <li>Designing systems that respect end-user autonomy, e.g. with privacy-preserving techniques.</li> <li>Avoiding extractive, chauvinist, “dark”, and otherwise “unethical” patterns of engagement.</li>",fe,S,Ve="Some example spaces for this category are:",pe,P,Ne='<li><a href="https://huggingface.co/spaces/AIML-TUDA/does-clip-know-my-face" rel="nofollow"><strong>Does CLIP Know My Face:</strong></a> this space lets you choose a model, enter your name and upload some pictures. Depending on this information, the model tries to predict your name from the images, if it predicts name correctly for multiple images there are high chances that you were part of the training data.</li> <li><a href="https://huggingface.co/spaces/RamAnanth1/photoguard" rel="nofollow"><strong>Photoguard:</strong></a> this space demonstrates an approach to safeguarding images against manipulation by ML-powered photo-editing models such as SD, through immunization of images.</li>',he,A,de,z,We="Socially Conscious work shows us how machine learning can support efforts toward a stronger society. Some examples:",ve,D,Qe="<li>Using machine learning as part of an effort to tackle climate change.</li> <li>Building tools to assist with medical research and practice.</li> <li>Models for text-to-speech, image captioning, and other tasks aimed at increasing accessibility.</li> <li>Creating systems for the digital humanities, such as for Indigenous language revitalization.</li>",we,E,Je="Some example spaces:",ye,I,Ke='<li><a href="https://huggingface.co/spaces/Geonmo/socratic-models-image-captioning-with-BLOOM" rel="nofollow"><strong>Socratic Models Image Captioning</strong></a></li> <li><a href="https://huggingface.co/spaces/nielsr/comparing-captioning-models" rel="nofollow"><strong>Comparing Image Captioning Models</strong></a></li>',$e,j,xe,q,Xe="This is work that highlights and explores techniques for making machine learning ecologically sustainable. Some examples:",be,F,Ye="<li>Tracking emissions from training and running inferences on large language models.</li> <li>Quantization and distillation methods to reduce carbon footprints without sacrificing model quality.</li>",Ce,R,Ze='<li><a href="https://huggingface.co/spaces/adirik/efficientformer" rel="nofollow"><strong>EfficientFormer</strong></a></li> <li><a href="https://huggingface.co/spaces/Ron0420/EfficientNetV2_Deepfakes_Video_Detector" rel="nofollow"><strong>EfficientNetV2 Deepfakes Video Detector</strong></a></li>',Te,U,Le,G,et="These are projects which broaden the scope of who builds and benefits in the machine learning world. Some examples:",He,B,tt="<li>Curating diverse datasets that increase the representation of underserved groups</li> <li>Training language models on languages that aren’t yet available on the Hugging Face Hub.</li> <li>Creating no-code and low-code frameworks that allow non-technical folk to engage with AI.</li>",Me,O,it='An example space is <a href="https://huggingface.co/spaces/microsoft/Promptist" rel="nofollow"><strong>Promptist Demo</strong></a>.',_e,V,ke,N,nt="Some projects take a radical new approach to concepts which may have become commonplace. These projects, often rooted in critical theory, shine a light on inequities and power structures which challenge the community to rethink its relationship to technology. Some examples:",Se,W,at="<li>Reframing AI and machine learning from Indigenous perspectives.</li> <li>Highlighting LGBTQIA2S+ marginalization in AI.</li> <li>Critiquing the harms perpetuated by AI systems.</li> <li>Discussing the role of “openness” in AI research.</li>",Pe,Q,ot='An example space is <a href="https://huggingface.co/spaces/merve/dataset-worldviews" rel="nofollow"><strong>PAIR: Datasets Have Worldviews</strong></a>.',Ae,J,st='Finally, if you would like to explore more about Hugging Face’s efforts, do check out the <a href="https://huggingface.co/society-ethics" rel="nofollow"><strong>Society and Ethics</strong></a> organzation on Hugging Face. Also check out the dedicated channel on <a href="https://discord.gg/hugging-face-879548962464493619" rel="nofollow"><strong>#ethics-and-society</strong></a>.',ze,K,De,Y,Ee;return v=new d({props:{title:"Hugging Face’s efforts: Ethics and Society 🤗🌎",local:"hugging-faces-efforts-ethics-and-society-",headingTag:"h1"}}),y=new d({props:{title:"Democratizing Good ML 🤗",local:"democratizing-good-ml-",headingTag:"h2"}}),x=new d({props:{title:"Categories of Hugging Face Spaces",local:"categories-of-hugging-face-spaces",headingTag:"h2"}}),C=new d({props:{title:"✍️ Rigorous",local:"-rigorous",headingTag:"h3"}}),M=new d({props:{title:"🤝 Consentful",local:"-consentful",headingTag:"h3"}}),A=new d({props:{title:"👁️‍🗨️ Socially Conscious",local:"-socially-conscious",headingTag:"h3"}}),j=new d({props:{title:"🌎 Sustainable",local:"-sustainable",headingTag:"h3"}}),U=new d({props:{title:"🧑‍🤝‍🧑 Inclusive",local:"-inclusive",headingTag:"h3"}}),V=new d({props:{title:"🤔 Inquisitive",local:"-inquisitive",headingTag:"h3"}}),K=new dt({props:{source:"https://github.com/johko/computer-vision-course/blob/main/chapters/en/unit12/conclusion.mdx"}}),{c(){h=s("meta"),Z=a(),X=s("p"),ee=a(),c(v.$$.fragment),te=a(),w=s("p"),w.innerHTML=je,ie=a(),c(y.$$.fragment),ne=a(),$=s("p"),$.innerHTML=qe,ae=a(),c(x.$$.fragment),oe=a(),b=s("p"),b.textContent=Fe,se=a(),c(C.$$.fragment),le=a(),T=s("p"),T.textContent=Re,re=a(),L=s("ul"),L.innerHTML=Ue,ce=a(),H=s("p"),H.innerHTML=Ge,ge=a(),c(M.$$.fragment),me=a(),_=s("p"),_.textContent=Be,ue=a(),k=s("ul"),k.innerHTML=Oe,fe=a(),S=s("p"),S.textContent=Ve,pe=a(),P=s("ol"),P.innerHTML=Ne,he=a(),c(A.$$.fragment),de=a(),z=s("p"),z.textContent=We,ve=a(),D=s("ul"),D.innerHTML=Qe,we=a(),E=s("p"),E.textContent=Je,ye=a(),I=s("ol"),I.innerHTML=Ke,$e=a(),c(j.$$.fragment),xe=a(),q=s("p"),q.textContent=Xe,be=a(),F=s("ul"),F.innerHTML=Ye,Ce=a(),R=s("ol"),R.innerHTML=Ze,Te=a(),c(U.$$.fragment),Le=a(),G=s("p"),G.textContent=et,He=a(),B=s("ul"),B.innerHTML=tt,Me=a(),O=s("p"),O.innerHTML=it,_e=a(),c(V.$$.fragment),ke=a(),N=s("p"),N.textContent=nt,Se=a(),W=s("ul"),W.innerHTML=at,Pe=a(),Q=s("p"),Q.innerHTML=ot,Ae=a(),J=s("p"),J.innerHTML=st,ze=a(),c(K.$$.fragment),De=a(),Y=s("p"),this.h()},l(e){const t=pt("svelte-u9bgzb",document.head);h=l(t,"META",{name:!0,content:!0}),t.forEach(i),Z=o(e),X=l(e,"P",{}),lt(X).forEach(i),ee=o(e),g(v.$$.fragment,e),te=o(e),w=l(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1efpqzw"&&(w.innerHTML=je),ie=o(e),g(y.$$.fragment,e),ne=o(e),$=l(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-1yx93ur"&&($.innerHTML=qe),ae=o(e),g(x.$$.fragment,e),oe=o(e),b=l(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-1wvga4p"&&(b.textContent=Fe),se=o(e),g(C.$$.fragment,e),le=o(e),T=l(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-46a3g4"&&(T.textContent=Re),re=o(e),L=l(e,"UL",{"data-svelte-h":!0}),r(L)!=="svelte-1bni1se"&&(L.innerHTML=Ue),ce=o(e),H=l(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-atg9y"&&(H.innerHTML=Ge),ge=o(e),g(M.$$.fragment,e),me=o(e),_=l(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-fioi3n"&&(_.textContent=Be),ue=o(e),k=l(e,"UL",{"data-svelte-h":!0}),r(k)!=="svelte-3hltui"&&(k.innerHTML=Oe),fe=o(e),S=l(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-i9zcru"&&(S.textContent=Ve),pe=o(e),P=l(e,"OL",{"data-svelte-h":!0}),r(P)!=="svelte-16jekji"&&(P.innerHTML=Ne),he=o(e),g(A.$$.fragment,e),de=o(e),z=l(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-eeobdf"&&(z.textContent=We),ve=o(e),D=l(e,"UL",{"data-svelte-h":!0}),r(D)!=="svelte-7j1s8u"&&(D.innerHTML=Qe),we=o(e),E=l(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-1civgnz"&&(E.textContent=Je),ye=o(e),I=l(e,"OL",{"data-svelte-h":!0}),r(I)!=="svelte-eecl4f"&&(I.innerHTML=Ke),$e=o(e),g(j.$$.fragment,e),xe=o(e),q=l(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-1zmd9n"&&(q.textContent=Xe),be=o(e),F=l(e,"UL",{"data-svelte-h":!0}),r(F)!=="svelte-ucq62j"&&(F.innerHTML=Ye),Ce=o(e),R=l(e,"OL",{"data-svelte-h":!0}),r(R)!=="svelte-744dzg"&&(R.innerHTML=Ze),Te=o(e),g(U.$$.fragment,e),Le=o(e),G=l(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-zw6twt"&&(G.textContent=et),He=o(e),B=l(e,"UL",{"data-svelte-h":!0}),r(B)!=="svelte-1s9mo4d"&&(B.innerHTML=tt),Me=o(e),O=l(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1syct0j"&&(O.innerHTML=it),_e=o(e),g(V.$$.fragment,e),ke=o(e),N=l(e,"P",{"data-svelte-h":!0}),r(N)!=="svelte-1p66ki1"&&(N.textContent=nt),Se=o(e),W=l(e,"UL",{"data-svelte-h":!0}),r(W)!=="svelte-2s9fvm"&&(W.innerHTML=at),Pe=o(e),Q=l(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-s1ugqh"&&(Q.innerHTML=ot),Ae=o(e),J=l(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-16v23z8"&&(J.innerHTML=st),ze=o(e),g(K.$$.fragment,e),De=o(e),Y=l(e,"P",{}),lt(Y).forEach(i),this.h()},h(){rt(h,"name","hf:doc:metadata"),rt(h,"content",wt)},m(e,t){ht(document.head,h),n(e,Z,t),n(e,X,t),n(e,ee,t),m(v,e,t),n(e,te,t),n(e,w,t),n(e,ie,t),m(y,e,t),n(e,ne,t),n(e,$,t),n(e,ae,t),m(x,e,t),n(e,oe,t),n(e,b,t),n(e,se,t),m(C,e,t),n(e,le,t),n(e,T,t),n(e,re,t),n(e,L,t),n(e,ce,t),n(e,H,t),n(e,ge,t),m(M,e,t),n(e,me,t),n(e,_,t),n(e,ue,t),n(e,k,t),n(e,fe,t),n(e,S,t),n(e,pe,t),n(e,P,t),n(e,he,t),m(A,e,t),n(e,de,t),n(e,z,t),n(e,ve,t),n(e,D,t),n(e,we,t),n(e,E,t),n(e,ye,t),n(e,I,t),n(e,$e,t),m(j,e,t),n(e,xe,t),n(e,q,t),n(e,be,t),n(e,F,t),n(e,Ce,t),n(e,R,t),n(e,Te,t),m(U,e,t),n(e,Le,t),n(e,G,t),n(e,He,t),n(e,B,t),n(e,Me,t),n(e,O,t),n(e,_e,t),m(V,e,t),n(e,ke,t),n(e,N,t),n(e,Se,t),n(e,W,t),n(e,Pe,t),n(e,Q,t),n(e,Ae,t),n(e,J,t),n(e,ze,t),m(K,e,t),n(e,De,t),n(e,Y,t),Ee=!0},p:gt,i(e){Ee||(u(v.$$.fragment,e),u(y.$$.fragment,e),u(x.$$.fragment,e),u(C.$$.fragment,e),u(M.$$.fragment,e),u(A.$$.fragment,e),u(j.$$.fragment,e),u(U.$$.fragment,e),u(V.$$.fragment,e),u(K.$$.fragment,e),Ee=!0)},o(e){f(v.$$.fragment,e),f(y.$$.fragment,e),f(x.$$.fragment,e),f(C.$$.fragment,e),f(M.$$.fragment,e),f(A.$$.fragment,e),f(j.$$.fragment,e),f(U.$$.fragment,e),f(V.$$.fragment,e),f(K.$$.fragment,e),Ee=!1},d(e){e&&(i(Z),i(X),i(ee),i(te),i(w),i(ie),i(ne),i($),i(ae),i(oe),i(b),i(se),i(le),i(T),i(re),i(L),i(ce),i(H),i(ge),i(me),i(_),i(ue),i(k),i(fe),i(S),i(pe),i(P),i(he),i(de),i(z),i(ve),i(D),i(we),i(E),i(ye),i(I),i($e),i(xe),i(q),i(be),i(F),i(Ce),i(R),i(Te),i(Le),i(G),i(He),i(B),i(Me),i(O),i(_e),i(ke),i(N),i(Se),i(W),i(Pe),i(Q),i(Ae),i(J),i(ze),i(De),i(Y)),i(h),p(v,e),p(y,e),p(x,e),p(C,e),p(M,e),p(A,e),p(j,e),p(U,e),p(V,e),p(K,e)}}}const wt='{"title":"Hugging Face’s efforts: Ethics and Society 🤗🌎","local":"hugging-faces-efforts-ethics-and-society-","sections":[{"title":"Democratizing Good ML 🤗","local":"democratizing-good-ml-","sections":[],"depth":2},{"title":"Categories of Hugging Face Spaces","local":"categories-of-hugging-face-spaces","sections":[{"title":"✍️ Rigorous","local":"-rigorous","sections":[],"depth":3},{"title":"🤝 Consentful","local":"-consentful","sections":[],"depth":3},{"title":"👁️‍🗨️ Socially Conscious","local":"-socially-conscious","sections":[],"depth":3},{"title":"🌎 Sustainable","local":"-sustainable","sections":[],"depth":3},{"title":"🧑‍🤝‍🧑 Inclusive","local":"-inclusive","sections":[],"depth":3},{"title":"🤔 Inquisitive","local":"-inquisitive","sections":[],"depth":3}],"depth":2}],"depth":1}';function yt(Ie){return mt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ct extends ut{constructor(h){super(),ft(this,h,yt,vt,ct,{})}}export{Ct as component};
